unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses PdfiumCore, PdfiumCtrl, PdfiumLib;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  With TOpenDialog.Create(nil) do
  try
    DefaultExt  := '.pdf';
    Options     := Options + [TOpenOption.ofAllowMultiSelect];
    Filter      := '*.pdf|*.pdf';
    if Execute then
    begin
      while Files.Count > 0 do
      begin
        ListBox1.Items.Add(Files[0]);
        Files.Delete(0);
      end;
    end;
  finally
    free;
  end;
end;

function MergePdfFiles( aList: TStrings ):TPdfControl;
var
  LPdf : TPdfDocument;
begin
  {$IFDEF CPUX64}
  PDFiumDllDir := ExtractFilePath(ParamStr(0)) + 'x64';
  {$ELSE}
  PDFiumDllDir := ExtractFilePath(ParamStr(0)) + 'x86';
  {$ENDIF CPUX64}

  result := TPdfControl.Create(nil);
  result.Align      := alClient;
//result.Parent     := Self;
//result.SendToBack; // put the control behind the buttons
  result.Color      := clGray;
//result.Color      := clWhite;
//result.PageBorderColor := clBlack;
//result.PageShadowColor := clDkGray;
  result.ScaleMode  := smFitWidth;
  result.PageColor  := RGB(255, 255, 200);
//result.OnWebLinkClick := WebLinkClick;
//edtZoom.Value := result.ZoomPercentage;

  result.LoadFromFile(aList[0]); // Referans
  aList.Delete(0);
  LPdf := TPdfDocument.Create;
  try
    while aList.Count > 0 do
    begin
        LPdf.LoadFromFile(aList[0]);
        result.Document.ImportAllPages(LPdf);
        aList.Delete(0);
    end;
  finally
    freeAndNil(LPdf);
  end;
end;


procedure TForm1.BitBtn2Click(Sender: TObject);
var
  LFinalPdf : TPDFControl;
begin
  With TSaveDialog.Create(nil) do
  try
    Filter      := '*.pdf|*.pdf';
    DefaultExt  := '.pdf';
    if Execute then
    begin
      LFinalPdf := MergePdfFiles(ListBox1.Items);
      try
        LFinalPdf.Document.SaveToFile( changefileext(FileName, DefaultExt) );
      finally
        freeAndNil(LFinalPdf);
      end;
    end;
  finally
    free;
  end;
end;

end.
